package io.github.flemmli97.flan.config;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import io.github.flemmli97.flan.CrossPlatformStuff;
import io.github.flemmli97.flan.api.permission.ClaimPermission;
import io.github.flemmli97.flan.api.permission.PermissionRegistry;
import net.minecraft.server.MinecraftServer;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.reflect.Field;

public class LangConfig {

    private File config;

    public String noClaim = "There is no claim here.";
    public String inspectBlockOwner = "This is %1$s's claim";
    public String inspectNoClaim = "Nobody owns this block";
    public String claimBlocksFormat = "Claim Blocks: %1$d + (Bonus) %2$d; Used: %3$d";
    public String listClaims = "Listing all claims:";
    public String listAdminClaims = "Listing all admin-claims in %1$s:";
    public String onlyOnePlayer = "Only one player can be used as argument";
    public String ownerTransferSuccess = "New Claimowner now: %1$s";
    public String ownerTransferFail = "Only the owner may transfer claims";
    public String ownerTransferNoBlocks = "The new owner doesnt have enough claimblocks";
    public String ownerTransferNoBlocksAdmin = "You can ignore this by switching to admin mode";

    public String noPermission = "You don't have the required permissions to do that here!";
    public String noPermissionSimple = "Sorry you can't do that here!";

    public String configReload = "Configs reloaded";

    public String cantClaimHere = "Sorry you cant claim here";
    public String minClaimSize = "This is too small. Minimum claimsize is %d";
    public String maxClaims = "Maximum amount of claims reached";
    public String landClaimDisabledWorld = "Claiming is disabled in this world";
    public String editMode = "Editing mode set to %1$s";
    public String notEnoughBlocks = "Not enough claim blocks";
    public String conflictOther = "Claim would overlap other claims";
    public String wrongMode = "Wrong claim mode. You are in %1$s-mode";
    public String stringScreenReturn = "Click on paper to go back";

    public String groupAdd = "Added group %1$s";
    public String groupRemove = "Removed group %1$s";
    public String groupExist = "Group already exist";
    public String playerModify = "Modified permission group for following players to %1$s: %2$s";
    public String playerModifyNo = "Couldn't set permission group for the players. Probably cause they already belong to a group";
    public String playerGroupAddFail = "Couldn't add that player to the group either cause the player " +
            "is already in a group or no player matching the name was found";
    public String resizeClaim = "Resizing claim";
    public String resizeSuccess = "Resized Claims";
    public String claimCreateSuccess = "Created a new claim";
    public String subClaimCreateSuccess = "Created a new subclaim";
    public String deleteClaim = "Claim deleted";
    public String deleteAllClaimConfirm = "Are you sure you want to delete all claims? Type it again to confirm";
    public String deleteAllClaim = "All claims deleted";
    public String deleteClaimError = "You can't delete this claim here";
    public String deleteSubClaim = "Subclaim deleted";
    public String deleteSubClaimAll = "All Subclaims from this claim deleted";
    public String noSuchPerm = "No such Permission %1$s";
    public String editPerm = "%1$s now set to %2$s";
    public String editPermGroup = "%1$s for %2$s now set to %3$s";
    public String editPersonalGroup = "Default permission %1$s for group %2$s now set to %3$s";

    public String adminMode = "Adminmode (Ignore Claims) set to: %1$s";
    public String adminDeleteAll = "Deleted all claims for following players: %1$s";
    public String setAdminClaim = "Adminclaim of this claim now: %1$s";
    public String readGriefpreventionData = "Reading data from GriefPrevention";
    public String readGriefpreventionClaimDataSuccess = "Successfully read claim data";
    public String readGriefpreventionPlayerDataSuccess = "Successfully read player data";
    public String cantFindData = "No griefprevention data at %1$s";
    public String errorFile = "Error reading file %1$s";
    public String readConflict = "%1$s conflicts with existing claims. Not added to world! Conflicts:";
    public String giveClaimBlocks = "Gave following players %2$d claimblocks: %1$s";

    public String claimBasicInfo = "Owner: %1$s, from: [x=%2$d,z=%3$d] to [x=%4$d,z=%5$d]; Subclaim-amount: %6$d";
    public String claimBasicInfoNamed = "Claim: %7$s, Owner: %1$s, from: [x=%2$d,z=%3$d] to [x=%4$d,z=%5$d]; Subclaim-amount: %6$d";
    public String claimSubHeader = "==SubclaimInfo==";
    public String claimBasicInfoSub = "Owner: %1$s, from: [x=%2$d,z=%3$d] to [x=%4$d,z=%5$d]";
    public String claimBasicInfoSubNamed = "Claim: %6$s, Owner: %1$s, from: [x=%2$d,z=%3$d] to [x=%4$d,z=%5$d]";
    public String claimInfoPerms = "Permissions: %1$s";
    public String claimGroupInfoHeader = "Groups: ";
    public String claimGroupPerms = "    Permissions: %1$s";
    public String claimGroupPlayers = "    Players: %1$s";
    public String helpHeader = "Available subcommands are (page %d):";
    public String helpCmdHeader = "====================";
    public String helpCmdSyntax = "Syntax: %1$s";

    public String screenEnableText = "Enabled: %1$s";
    public String screenUneditable = "Non Editable!";
    public String screenClose = "Close";
    public String screenNext = "Next";
    public String screenPrevious = "Prev";
    public String screenAdd = "Add";
    public String screenBack = "Back";
    public String screenNoPerm = "No Permission";
    public String screenFalse = "false";
    public String screenTrue = "true";
    public String screenDefault = "default";

    public String screenMenu = "Claim-Menu";
    public String screenMenuSub = "SubClaim-Menu";
    public String screenMenuGlobal = "Edit Global Permissions";
    public String screenMenuGroup = "Edit Permissiongroups";
    public String screenMenuPotion = "Edit Potioneffects";
    public String screenMenuClaimText = "Edit Enter/Leave Text";
    public String screenMenuDelete = "Delete Claim";
    public String screenConfirm = "Confirm";
    public String screenYes = "Yes";
    public String screenNo = "No";
    public String screenGroupPlayers = "%1$s-Players";
    public String screenRemoveMode = "Remove Mode: %1$s";
    public String screenGlobalPerms = "Global-Permissions";
    public String screenGroups = "Claim-Groups";
    public String screenGroupPerms = "%1$s-Permissions";
    public String screenPersonalGroups = "Personal-Groups";
    public String screenPersonalPermissions = "Personal Permissions for %1$s";
    public String screenPotions = "Claim Potions";
    public String screenTitleEditor = "Claim messages";
    public String screenTitleEditorSub = "Subclaim messages";
    public String screenEnterText = "Edit title text on enter. (Right-Click to use JSON text. See MC Wiki for that)";
    public String screenEnterSubText = "Edit subtitle text on enter. (Right-Click to use JSON text. See MC Wiki for that)";
    public String screenLeaveText = "Edit title text on leave. (Right-Click to use JSON text. See MC Wiki for that)";
    public String screenLeaveSubText = "Edit subtitle text on enter. (Right-Click to use JSON text. See MC Wiki for that)";

    public String chatClaimTextEdit = "[Click for command]";

    public String sellDisabled = "Claimblocks selling is disabled";
    public String buyDisabled = "Claimblocks purchasing is disabled";
    public String sellFail = "Not enough claimblocks to sell";
    public String buyFail = "Not enough money";
    public String sellSuccess = "Sold %1$s claimblocks for %2$s";
    public String buySuccess = "Bought %1$s claimblocks for %2$s";
    public String currencyMissing = "Missing a supported currency mod";

    public String trappedRescue = "Rescuing. Don't move for 5 seconds";
    public String trappedFail = "Rescue not necessary or already rescuing";
    public String trappedMove = "You moved. Aborting teleport";

    public String unlockDropsCmd = "Your deathitems are protected. Use %1$s to unlock them for other players";
    public String unlockDrops = "Your deathitems are now unlocked for %1$s ticks";
    public String unlockDropsMulti = "Unlocked drops for %1$s";

    public String claimNameSet = "Claims name set to %1$s";
    public String claimNameUsed = "The owner of the claim already has another claim with the same name";
    public String claimNameUsedSub = "One of the subclaim of this claim already has this name";

    public String setHome = "Claim home set to [x=%1$s,y=%2$s,z=%3$s]";
    public String teleportHome = "Teleporting to claim home. Don't move for 5 seconds";
    public String teleportHomeFail = "Teleport already happening";

    public String setEnterMessage = "Set enter title to %1$s";
    public String setEnterSubMessage = "Set enter subtitle to %1$s";
    public String setLeaveMessage = "Set leave title to %1$s";
    public String setLeaveSubMessage = "Set leave subtitle to %1$s";

    public String wiki = "For more info check out the wiki:";

    public LangCommands cmdLang = new LangCommands();

    public LangConfig(MinecraftServer server) {
        File configDir = CrossPlatformStuff.configPath().resolve("flan").toFile();
        //server.getSavePath(WorldSavePath.ROOT).resolve("config/claimConfigs").toFile();
        try {
            if (!configDir.exists())
                configDir.mkdirs();
            this.config = new File(configDir, "flan_lang.json");
            if (!this.config.exists()) {
                this.config.createNewFile();
                this.save();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void load() {
        try {
            FileReader reader = new FileReader(this.config);
            JsonObject obj = ConfigHandler.GSON.fromJson(reader, JsonObject.class);
            reader.close();
            for (Field field : this.getClass().getDeclaredFields()) {
                if (field.getType().equals(String.class) && obj.has(field.getName())) {
                    field.set(this, obj.get(field.getName()).getAsString());
                }
            }
            for (ClaimPermission perm : PermissionRegistry.getPerms()) {
                if (obj.has(perm.id + ".desc")) {
                    JsonElement pe = obj.get(perm.id + ".desc");
                    if (pe.isJsonObject())
                        throw new JsonParseException("Lang cant be json objects");
                    if (pe.isJsonArray()) {
                        String[] l = new String[pe.getAsJsonArray().size()];
                        for (int i = 0; i < l.length; i++)
                            l[i] = pe.getAsJsonArray().get(i).getAsString();
                        perm.desc = l;
                    } else
                        perm.desc = new String[]{pe.getAsString()};
                }
            }
            JsonObject cmd = ConfigHandler.fromJson(obj, "commands");
            this.cmdLang.load(cmd);
        } catch (IOException | IllegalAccessException e) {
            e.printStackTrace();
        }
        this.save();
    }

    private void save() {
        JsonObject obj = new JsonObject();
        try {
            for (Field field : this.getClass().getDeclaredFields()) {
                if (field.getType().equals(String.class)) {
                    obj.addProperty(field.getName(), (String) field.get(this));
                }
            }
            for (ClaimPermission perm : PermissionRegistry.getPerms()) {
                if (perm.desc.length == 1)
                    obj.addProperty(perm.id + ".desc", perm.desc[0]);
                else {
                    JsonArray arr = new JsonArray();
                    for (String s : perm.desc)
                        arr.add(s);
                    obj.add(perm.id + ".desc", arr);
                }
            }
            JsonObject cmd = new JsonObject();
            this.cmdLang.save(cmd);
            obj.add("commands", cmd);
            FileWriter writer = new FileWriter(this.config);
            ConfigHandler.GSON.toJson(obj, writer);
            writer.close();
        } catch (IOException | IllegalAccessException e) {
            e.printStackTrace();
        }
    }
}
